// ----------------------------------------------------
// piggyBank.h 
// Definiert die Klasse PiggyBank.
// ----------------------------------------------------

#ifndef _PIGGYBANK_
#define _PIGGYBANK_

class PiggyBank {
private:
    unsigned int nCent1, nCent10, nCent50, nEuro1;  // Anzahl 1-Cent, 10-Cent, 50-Cent und 1-Euro Stcke
    unsigned int max;                               // Maximale Anzahl Mnzen
    bool fBroken;                                   // Flag fr aufgebrochenes Sparschwein
public:
    PiggyBank(unsigned int m) {
        max = m;                                    // Maximale Anzahl Mnzen
        nCent1 = nCent10 = nCent50 = nEuro1 = 0;
        fBroken = false;
    }
    ~PiggyBank() {}

    bool isEmpty();
    bool isFull();
    bool isBroken();

    unsigned int add1Cents(unsigned int n1C);
    unsigned int add10Cents(unsigned int n10C);
    unsigned int add50Cents(unsigned int n50C);
    unsigned int add1Euros(unsigned int n1E);

    unsigned long breakInto(unsigned int& c1, unsigned int& c10, unsigned int& c50, unsigned int& e1);
};

inline bool PiggyBank::isEmpty() {
    unsigned int cur = nCent1 + nCent10 + nCent50 + nEuro1;
    return cur == 0;
}

inline bool PiggyBank::isFull() {
    unsigned int cur = nCent1 + nCent10 + nCent50 + nEuro1;
    return cur >= max;
}

inline bool PiggyBank::isBroken() {
    return fBroken;
}

#endif // _PIGGYBANK_
